/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.SubstanceAdministration.testcases.defaultscp;

import java.io.IOException;
import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.DicomV3Factory;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataTypeSQ;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumDataSource;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.IDataSource;

import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ProcessHandler;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.SCPSession;
import cdac.medinfo.sdk.dcm30_04.services.substanceadministration.sourceimpl.SubstanceAdministrationDataSourceImpl;
import cdac.medinfo.sdk.dcm30_04.services.substanceadministration.sourceimpl.SubstanceAdministration_StoreAgent;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
/**
 * This is the default implementation of the sample test code for  SubstanceAdministrationInfoQry Services.
 * This sample codes is to show the handling of connection, association and service request  by the default Process Handler Implementation of the SDK.
 * The Sample Test code should be extended from the ProcessHandler class of SDK for DICOM.
 * Then all the connection , association and service requests are handled by the default implementation
 * of the SDK.
 * To create DB for Substance Administration Information  refer SQL Script SubstanceAdministrationDB.sql provided in install.
 */
public class SubstanceAdministrationInfoQry_CFind_SCP_Def_ProcHandler 
{
	public static void main(String[] args) 
	{
		try
		{
			DicomConfig objDicomConfig = DicomConfig.createInstance();

			//enable logging,specify the path of the directory where log files are created. User can specify any directory in place of 'c:\DCM_Logs'.
			//If no directory is defined by user to create logs then it is created in User Temp DIR.
			objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");
			/*
			 * Populating Database with dataset on which find request will be processed.
			 */
			SubstanceAdministrationInfoQry_CFind_SCP_Def_ProcHandler objTest = new SubstanceAdministrationInfoQry_CFind_SCP_Def_ProcHandler();
			IDataSet objIDataSet = objTest.populateDataset();
			objTest.storeInstanceInfo(objIDataSet);

			SubstanceAdministrationInfoQry_CFind_SCPHandler objSubstanceAdministrationInfoQry_CFind_SCPHandler = new SubstanceAdministrationInfoQry_CFind_SCPHandler();
			objSubstanceAdministrationInfoQry_CFind_SCPHandler.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	/*
	 * This function populates the data set. SubstanceAdministrationInfoQry service query on instance populated.
	 */
	public IDataSet populateDataset()
	{
		IDataSet objIDataSet = new DataSet();
		IDictionaryReader objDictionaryReader = objIDataSet.getDictionaryReader();
		ITransferSyntax objTS = objIDataSet.getTransferSyntax();
		
		objIDataSet.addDataElement(getDataElement(0x0000,0x0002, EnumSOPClassUIDs.DCM_SUBSTANCE_APPROVAL_QUERY_SOP_CLASS.getValue(), objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0000,0x0120,  (short)10, objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0000,0x0800, (short)12, objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0010, "Harvey Specter", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0020, "MM123", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0021, "Dr. Mike Jose", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0030, "19740119", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0040, "M", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0038,0x0010, "9876", objDictionaryReader));

		IDataTypeSQ objConceptNameCodeSQ = getSQ(0x0038,0x0014,objTS);
		IItem objConceptNameCodeItem = objConceptNameCodeSQ.getNewItem();		
		objConceptNameCodeItem.addDataElement(getDataElement(0x0040,0x0031, "Case Medical Center", objDictionaryReader));		
		objConceptNameCodeSQ.addItem(objConceptNameCodeItem);
		objIDataSet.addDataElement(getDataElement(0x0038,0x0014,objConceptNameCodeSQ.getValue(), objDictionaryReader));
		
		objIDataSet.addDataElement(getDataElement(0x0044,0x0001, "01020201", objDictionaryReader));

		IDataTypeSQ objContentTemplateSQ = getSQ(0x0054,0x0302,objTS);
		IItem objContentTemplateItem = objContentTemplateSQ.getNewItem();
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0100, "T-28600", objDictionaryReader));
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0102, "SRT", objDictionaryReader));
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0104, "Slide", objDictionaryReader));
		objContentTemplateSQ.addItem(objContentTemplateItem);
		objIDataSet.addDataElement(getDataElement(0x0054,0x0302,objContentTemplateSQ.getValue(), objDictionaryReader));
		
		objIDataSet.addDataElement(getDataElement(0x0044,0x0002, "APPROVED", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0044,0x0003, "Req has been approved", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0044,0x0004, "20021114124623", objDictionaryReader));

		return objIDataSet;
	}

	/*
	 * This function create the data element from the information provided.
	 */
	private IDataElement getDataElement(int GroupNo,int ElementNo,Object objVal,IDictionaryReader objDictionaryReader)
	{
		IDataElement objIDataElement = new ImplicitDE(GroupNo, ElementNo,objVal,objDictionaryReader);
		return objIDataElement;
	}

	/*
	 * This function gets the sequence belonging to group no and element number specified.
	 */
	private IDataTypeSQ getSQ(int GroupNo,int ElementNo , ITransferSyntax objTS)
	{
		return DicomV3Factory.createInstance().createSequence(GroupNo, ElementNo, objTS);
	}

	/*
	 * This function stores the dataset instance to database.
	 */
	public void storeInstanceInfo(IDataSet objIDataSet)
	{
		try
		{
			/*
			 * Create DataBase and store dataset to database using SubstanceAdministrationInfoQry_StoreAgent.
			 */
			String dataBasePath = "D:/SDKDatabase/SubstanceAdmininstrationDB.sql";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";
			SubstanceAdministration_StoreAgent objSubstanceAdministration_StoreAgent= new SubstanceAdministration_StoreAgent(ConnectionString, driverString);
			objSubstanceAdministration_StoreAgent.storeInstanceInfo(objIDataSet);
		}
		catch(Exception e)
		{
			System.out.println("Exception occured while insertion"+e.toString());
		}
	}
}

/**
 * This class inherits all the lifecycle methods involved in a communication with client.
 * This class is extended from the ProcessHandler class of the SDK for DICOM.
 * ProcessHandler class is the default processor of SDK for DICOM which is capable
 * of handling connection , association and service requests. It process all the request , 
 * generates response and sends it to SCU.
 * Once the required parameters are set on ProcessHandler class of SDK for DICOM
 * then it will handle all the Association and Service requests.
 */
class SubstanceAdministrationInfoQry_CFind_SCPHandler extends ProcessHandler
{
	/**
	 * Starts SCP server at iPort and local host.
	 * @throws IOException Signals IOException if IO operation fails.
	 */
	public void start()
	{
		try
		{
			/*
			 * Create SCP session.
			 */
			SCPSession objSCPSession = new SCPSession();

			/*
			 * Create DataSourceImpl with ConnectionString and driver String.
			 * DataSourceImpl is default implementation of library which uses JavaDB to 
			 * Store Data Elements.The user has to start javaDB server before connection
			 * if Client Server model in java DB is used.
			 * This DataSourceImpl should be set in CFind SCP.
			 * User can also provide its own implementation of IDataSource interface
			 * to store the attributes.
			 */
			String dataBasePath = "D:/SDKDatabase/SubstanceAdmininstrationDB.sql";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";

			IDataSource objSubstanceAdministrationInfoQryDataSource = new SubstanceAdministrationDataSourceImpl(ConnectionString,driverString);
			addDataSource(EnumDataSource.SUBSTANCE_ADMINISTRATION_INFO_QRY,objSubstanceAdministrationInfoQryDataSource);

			/*
			 * The session needs to be configured to load customized association according to service types selected. 
			 */
			EnumServiceType[] arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.CFIND_SUBSTANCEADMINISTRATION;
			objSCPSession.selectServices(arrenumServiceType);

			/*
			 * Set Process handler.
			 */
			objSCPSession.setIProcessHandler(this);
			/*
			 * Start the server.
			 */
			objSCPSession.start("SDK",9000);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	} 
}
